<?php

/**
 * resolucion_remision actions.
 *
 * @package    cobro_coactivo
 * @subpackage resolucion_remision
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class resolucion_remisionActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------* Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejar Errores
         */
        try {


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            if (isset($request['id_username'])) {
                $id_username = $request['id_username'];
            }

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 150;
            }

            //ordenar consulta
            if (isset($request['_sortBy'])) {
                $sortBy = " Order by " . $request['_sortBy'];
            } else {
                $sortBy = 'order by det.anho_remision, det.numero_remision, det.cod_titulo, concep.codigo, res.no_resolucion ';
            }

            /*
             * Filtros
             */
            $whereRemision = "";
            if (isset($request['id_remision_titulo'])) {
                $whereRemision = " AND det.id_remision_titulo = " . $request['id_remision_titulo'];
            }

            $whereRemisionIN = "";
            if (isset($request['id_remision_titulo_in'])) {
                $whereRemisionIN = " AND det.id_remision_titulo in (" . $request['id_remision_titulo_in'] . ")";
            }

            //input
            $whereInput = "";
            if (isset($request['input'])) {
                $whereInput = " AND res.no_resolucion_text like '%" . $request['input'] . "%'";
            }

            /*
             * Ejemplo:JKL-11561
             * Consulta de resolucioes con filtro de varias remisiones
             */
            $consulta = <<<EOD
select
res.id_resolucion_tit,
res.cod_titulo,
res.id_concepto_resol,
res.fecha_expedicion,
res.fecha_ejecutoria,
res.no_resolucion,
res.fecha_exigibilidad,
res.id_entidad_expide,
res.fecha_fin_exigibilidad,
res.fecha_log,
res.usuario_log,
res.titulo_vigente,
res.id_remision_titulo_det,
res.no_resolucion_det,
res.fecha_expedicion_det,
res.no_resolucion_text,
res.date_expedicion_text,
concep.descripcion as descripcion_concepto,
det.id_remision_titulo,
det.cod_titulo as titulo_minero,
det.numero_remision,
det.anho_remision,
det.numero_remision || ' - ' || det.anho_remision as completo_remision,
res.no_resolucion_text || ' - ' || concep.descripcion as completo_resol_text    

from cbr_resolucion_tit_v res

left join cbr_remision_titulo_det_v det
on det.id_remision_titulo_det  = res.id_remision_titulo_det

left join cbr_concepto_resol concep
on concep.id_concepto_resol = res.id_concepto_resol

where
1 = 1
$whereRemision                     
$whereRemisionIN  
$whereInput     
EOD;

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */

            $sql = <<<EOD
select count(*) as count from (

$consulta
                    
)
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            /*
             * Obtiene los registros de debito/vencimiento con su saldo respectivo
             */
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

$consulta
                        
$sortBy                        

) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($records);
            $this->list_data = $records;
            $this->logMessage("[resolucion_remision] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
